# Welcome

## Welcome to the BanyanDB

**BanyanDB**, as an observability database, aims to ingest, analyze and store Metrics, Tracing, and Logging data. It's
designed to handle observability data generated by **Apache SkyWalking**. Before BanyanDB emerges, the Databases that
SkyWalking adopted are not ideal for the APM data model, especially for saving tracing and logging data. Consequently,
There’s room to improve the performance and resource usage based on the nature of SkyWalking data patterns.

Here you can learn all you need to know about BanyanDB. Let's get started with it.

- **Guides**. Learn how to install, configure, and use BanyanDB by real-world examples.
- **Installation**. Instruments about how to download and onboard BanyanDB server, Banyand.
- **Interacting**. Learn how to interact with Banyand, including schema management, data ingestion, data retrieving and so on.
- **Operation**. Learn how to operate Banyand, including observability, troubleshooting, and so on.
- **Concept**. Learn the concepts of Banyand. Includes the architecture, data model, and so on.

### Useful Links

You might also find these links interesting:

- The latest and old releases are all available
  at [Apache SkyWalking release page](https://skywalking.apache.org/downloads/). The change logs can be
  found [here](https://github.com/apache/skywalking-banyandb/tree/master/CHANGES.md).

- [SkyWalking WIKI](https://cwiki.apache.org/confluence/display/SKYWALKING/Home) hosts the context of some changes and
  events.

- You can find the conference schedules, video recordings, and articles about SkyWalking in
  the [community resource catalog](https://github.com/OpenSkywalking/Community).

### Contact Us

We're always looking for help to improve our documentation and codes, so please don’t hesitate
to [file an issue](https://github.com/apache/skywalking/issues/new) if you see any problems. Or better yet, directly
contribute by submitting a pull request to help us get better!
